<?php
/*******************************************************************************
 *	Index.php	Main Page for website
 *			T.Barnaby,	BEAM Ltd,	2008-02-08
 *******************************************************************************
 */
require_once "config.php";
require_once "BDatabase.php";
require_once "BCommon.php";
require_once "BObj.php";
require_once "BView.php";
require_once "BDate.php";
require_once "BDirectoryLister.php";
require_once "BPage.php";
require_once "BLogin.php";

//syslog(LOG_ERR, "Index.php running");

function createMenuBar(){
	global $state;
	
	// Create Menu bar
	$m = new BMenu();
	$m->add(new BMenuItem("Home", "/"));

	$ms = new BMenu("", array(
		"General Information" => "/files/index.html",
		));
	$m->add(new BMenuItem("Information", "", "", $ms));

	foreach($state->modules as $module){
		require_once "{$module}/{$module}.module";
		$obj = new $module();
		if($obj->checkAccess()){
			if($mt = $obj->getMenu()){
				$m->add($mt);
			}
		}
	}

	if($state->login->checkLogin("admin")){
		$ms = new BMenu("");
		foreach($state->modules as $module){
			require_once "{$module}/{$module}.module";
			$obj = new $module();
			if($obj->checkAccess()){
				$ms->add(new BMenuItem($obj->title, "/{$obj->name}"));
			}
		}
		$ms->add(new BMenuItem("Help", "/help/index.html", "target='_blank'"));
		$m->add(new BMenuItem("Admin", "/admin", "", $ms));
	}

	$state->page->setMenuBar($m);
}

function newsItem(){
	global $state;
	
	$objList = $state->db->getObjectList("News", "", "", "dateAdded DESC", "2");

	$html = new BHtmlNode("div", "id='news'");
	$html->appendNode("a", "href='{$state->baseUrl}/news.php'")->appendNode("h2", "", "News");
	
	if(count($objList) > 0){
		$obj = $objList[0];
		$d1 = &$html->appendNode("div", "class='NewsSummary'");
		$d1->appendNode("div", "class='NewsSummaryPostdate'", $obj->dateAdded);
		$d1->appendNode("div", "class='NewsSummaryLink'")->appendNode("a", "href='{$state->baseUrl}/news.php?cmd=viewObj&id={$obj->id}'", $obj->title);
//		$d1->appendNode("div", "class='NewsSummaryCategory'", "Category: General");
//		$d1->appendNode("div", "class='NewsSummaryAuthor'", "Posted by: terry");
		$d1->appendNode("div", "class='NewsSummaryContent'", $obj->description);
	}

	if(count($objList) > 1){
		$obj = $objList[1];
		$d1 = &$html->appendNode("div", "class='NewsSummary'");
		$d1->appendNode("div", "class='NewsSummaryPostdate'", $obj->dateAdded);
		$d1->appendNode("div", "class='NewsSummaryLink'")->appendNode("a", "href='{$state->baseUrl}/news.php?cmd=viewObj&id={$obj->id}'", $obj->title);
//		$d1->appendNode("div", "class='NewsSummaryCategory'", "Category: General");
//		$d1->appendNode("div", "class='NewsSummaryAuthor'", "Posted by: terry");
		$d1->appendNode("div", "class='NewsSummaryContent'", $obj->description);
	}
	
	return $html->render();
}

function calendarItem(){
	global $state;
	
	$dateNow = new BDate("now");

	$objList = $state->db->getObjectList("Calendar", "", "`dateStart` >= '{$dateNow->get()}'", "dateStart limit 2");

	$html = new BHtmlNode("div", "id='news'");
	$html->appendNode("a", "href='{$state->baseUrl}/calendar.php'")->appendNode("h2", "", "Calendar");
	
	if(count($objList) > 0){
		$obj = $objList[0];
		$d1 = &$html->appendNode("div", "class='NewsSummary'");
		$d1->appendNode("div", "class='NewsSummaryPostdate'", $obj->dateStart);
		$d1->appendNode("div", "class='NewsSummaryLink'")->appendNode("a", "href='{$state->baseUrl}/calendar.php?cmd=viewObj&id={$obj->id}'", $obj->title);
		$d1->appendNode("div", "class='NewsSummaryContent'", $obj->description);
	}

	if(count($objList) > 1){
		$obj = $objList[1];
		$d1 = &$html->appendNode("div", "class='NewsSummary'");
		$d1->appendNode("div", "class='NewsSummaryPostdate'", $obj->dateStart);
		$d1->appendNode("div", "class='NewsSummaryLink'")->appendNode("a", "href='{$state->baseUrl}/calendar.php?cmd=viewObj&id={$obj->id}'", $obj->title);
		$d1->appendNode("div", "class='NewsSummaryContent'", $obj->description);
	}

	return $html->render();
}

function stdHomePage(){
	global $state;
	
	$html =	htmlParse("files/index.html");
	$content = $html['body'];

	$html = new BHtmlNode("table", "width='100%'");
	$r = &$html->appendNode("tr");
//	$r->appendNode("td", "valign='top' width='50%'", newsItem());
//	$r->appendNode("td", "valign='top' width='50%'", calendarItem());

	$content = $content . $html->render();

	pageDisplay($state->title, $content);
}


function addItem($icon, $title, $description, $url, $subItems){
	$h = new BHtmlNode("div", "class='adminItem'");
	$t = &$h->appendNode("table");
	$r = &$t->appendNode("tr");
	$c = &$t->appendNode("td");
	$c->appendNode("a", "href='{$url}'")->appendNode("img", "src='{$icon}'");
	$c = &$t->appendNode("td");
	$c->appendNode("a", "href='{$url}'", $title);
	$c->appendNode("br");
	$c->appendText($description);
	return $h->render();
}

function adminHomePage(){
	global $state;
	
	$col = 0;
	
	$h = new BHtmlNode("div");
	$h->appendNode("h1", "", "Admin Top");


	$t = &$h->appendNode("table");
	foreach($state->modules as $module){
		if($col == 0)
			$r = &$t->appendNode("tr");
			
		$c = &$r->appendNode("td");
		require_once "{$module}/{$module}.module";
		$obj = new $module();
		if($obj->checkAccess())
			$c->appendText(addItem("{$state->baseUrl}/icons/topfiles/pages.gif", $obj->title, $obj->info, "{$state->baseUrl}/{$obj->name}", Null));
		if($col++ == 1)
			$col = 0;
	}
	$r = &$t->appendNode("tr");
	$c = &$r->appendNode("td");
	$c->appendText(addItem("{$state->baseUrl}/icons/topfiles/pages.gif", "Help", "Help information on using this website", "{$state->baseUrl}/help/index.html", Null));

	pageDisplay("Administration Top", $h->render());
}




function processModule($uri) {
	global $state;

	require_once "{$uri}/{$uri}.module";
	$module = new $uri();
	
	$content = $module->getPage($uri);

	if($content != null){
		if($module->getPageBlock($uri))
			$state->page->leftObjectInsert($module->getPageBlock($uri));
		pageDisplay($module->title, $content);
	}
}

function processContent($uri) {
	global $state;
	
	require_once "content/content.module";
	$module = new Content();
	
	$page = $module->getPage($uri);

	if($page != null){
		if($module->getPageBlock($uri))
			$state->page->leftObjectInsert($module->getPageBlock($uri));
		pageDisplay($module->title, $page);
	}
}

function processDir($uri){
	global $state;

	$dirl = new BDirectoryLister;
	
	pageDisplay($uri, $dirl->createList($uri));
}


function processUri($uri){
	global $state;

	if(in_array($uri, $state->modules)){
		processModule($uri);
	}
	else if(($uri == $state->basePath) || ($uri == ($state->basePath . "index.php"))){
		stdHomePage();
	}
	else if($uri == "admin"){
		adminHomePage();
	}
	else {
		if(preg_match("/.*\.html/", $uri)){
			processContent($uri);
		}
		else if(is_dir($uri)){
			if(file_exists($uri . "index.html")){
				processContent($uri . "index.html");
			}
			else {
				print "Dir contents";
				processDir($uri);
			}
		}
		else if(file_exists($uri)){
			print file_get_contents($uri);
		}
		else {
			pageDisplayError(new BError(1, "File: {$uri} not found"));
		}
	}
}


/*******************************************************************************
 *	Main code
 *******************************************************************************
 */

//print "Beam index.php Uri: {$uri}<br>\n";
//print "BaseUrl: {$state->baseUrl}  BaseDir: {$state->baseDir}  BasePath: {$state->basePath}<br>\n";
//print_r($_SERVER);
//print_r($_POST);

// Create database connection
$state->db = new BDataBase($state);

// Start off session
session_start();

if(isset($_SESSION["style"])){
	$state->style = $_SESSION["style"];
}

// Create main page
$page = new BPageTemplate($state);
$state->page = $page;

// Load the required modules
modulesLoad();

// Get Login info
$login = new BLogin($state, "pageLogin", false);
$state->login = $login;

// Get query
if(isset($_GET["q"])){
	$uri = $_GET["q"];
}
else {
	$uri = $_SERVER['REQUEST_URI'];
}

// Update Statistics
statisticsAdd();

createMenuBar();

// Add user login info
$obj = new user();
$page->leftObjectInsert($obj->getLoginBlock($uri));
	
if($state->loginRequired){
	$login = new BLogin($state, "pageLogin1", true);

	if(!$login->checkLogin()){
		exit();
	}

	if(isset($_GET['cmd']) && ($_GET['cmd'] == "logout")){
		$login->logout();
		header ("Location: index.php");
	}
}

// Setup user information
if($login->id)
	$state->user = $state->db->getObject("User", $login->id);

processUri($uri);

?>
