<?php
/*******************************************************************************
 *	CreateTables.php	Create Tables
 *				T.Barnaby,	BEAM Ltd,	2008-01-08
 *******************************************************************************
 */
require_once "../config.php";
require_once "BDatabase.php";
require_once "BCommon.php";
require_once "BObj.php";

function createTables($force = 0){
	global $state;
	
	$page = "";
	
	$objClasses = $state->db->getObjectClasses();
	foreach($state->db->getObjectClasses() as $k => $c){
		print "Obj: {$k} => {$c}<br>";
		
		$obj = new $c;
		
		// Check if table exists
		$ti = $state->db->getTableInfo($k);

//		print "TableInfo: {$ti}<br>";
//		print "TableFields: {$obj->dbTableFields()}<br>";
		
		if(! $ti or $force){
			if($obj->dbTableFields() == ""){
				$page .= "Warning: No database fields defined for Object: {$c}<br>";
			}
			else {
				$page .= "Create Table {$k}<br>";
				$state->db->dropTable($k);
				$state->db->createTable($k, $obj->dbTableFields());
			}

			$obj->dbTableSetup($k);
		}
	}
	return $page;
}

// Create database connection
$state->db = new BDataBase($state);

// Load the required modules
modulesLoad();

$content = createTables();

$content .= "Tables created";

print $content;

?>
