<?php
/*******************************************************************************
 *	BCommon.php		General routines
 *				T.Barnaby,	BEAM Ltd,	2008-01-06
 *******************************************************************************
 */
require_once "BHtml.php";

function dateString($date){
	if($date == "")
		return "";
	else
		return date_format(new DateTime($date), "d/m/Y");
}

function pageDisplay($title, $content){
	global $state;

	$state->page->setTitle($state->siteTitle);
	$state->page->setCentre($content);
	$state->page->render();
}

function pageDisplayError(BError $err){
	global $state;
	
	$back = $_SERVER["HTTP_REFERER"];

	$html = "<div class='error'>\n";
	$html .= "<h1>Error</h1>\n";
	$html .= "{$err->getString()}\n";
	$html .= "</div>\n";
	$html .= "<a href='{$back}'>Back</a>\n";
	
	$state->page->setStatus("<span class='error'>An error occured</span>");
	pageDisplay("{$state->siteName} - Error", $html);
}

function pageDisplayPopup($title, $content){
	global $state;

	$state->page->popup = 1;
	$state->page->setTitle($title);
	$state->page->setCentre($content);
	$state->page->render();
}

class ObjLocal {
	var	$id;
	var	$title;
};
	
function getPictureHtml($id = 0, $category = "", $thumb = 0){
	global $state;

	$select = "";

	if($id){
		$obj = $state->db->getObject("Picture", $id);
	}
	else {
		if($category){
			$category = dbEscapeString($category);
			$select = "`category` = '{$category}'";
		}
		$list = $state->db->getObjectList("Picture", "", $select, "");
		if(count($list)){
			$obj = $list[0];
		}
		else {
			$obj = new ObjLocal;
			$obj->id = 0;
			$obj->title = "No image";
		}
	}		

	if($thumb)
		$html = "<img alt='{$obj->title}' title='{$obj->title}' src='{$state->baseUrl}/files/pictures/picture-{$obj->id}-thumb.jpg'>";
	else
		$html = "<img alt='{$obj->title}' title='{$obj->title}' src='{$state->baseUrl}/files/pictures/picture-{$obj->id}.jpg'>";

	return $html;
}

class BLoginForm {
	function BLoginForm(){
		$this->type = "BLoginForm";
		$this->title = "Account";
	}
	function rebaseMenu(){
	}
	function render(){
		global $state;

		$page = new BHtmlNode("div", "class='loginLeft'");
		$f = &$page->appendNode("form", "method='post' action='{$state->baseUrl}/user?cmd=login'");
		$t = &$f->appendNode("table");
		$r = &$t->appendNode("tr");
		$c = &$r->appendNode("td");
		$c->appendText("Username");
		$r = &$t->appendNode("tr");
		$c = &$r->appendNode("td");
		$c->appendNode("input", "class='loginEntry' type='text' name='username'");

		$r = &$t->appendNode("tr");
		$c = &$r->appendNode("td");
		$c->appendText("Password");
		$r = &$t->appendNode("tr");
		$c = &$r->appendNode("td");
		$c->appendNode("input", "class='loginEntry' type='password' name='password'");

		$r = &$t->appendNode("tr");
		$c = &$r->appendNode("td");
		$c->appendNode("input", "class='loginButton' type='submit' value='Login Now'");

		if(!$state->loginRequired){
			$r = &$t->appendNode("tr");
			$c = &$r->appendNode("td");
			$c->appendNode("a", "href='{$state->baseUrl}/user?cmd=register'", "Create New Account");
		}
 
		return $page->render();
//		return "Test";
	}
}

class BLogoutForm {
	function BLogoutForm(){
		$this->type = "BLogoutForm";
		$this->title = "Account";
	}
	function rebaseMenu(){
	}
	function render(){
		global $state;
		
		$page = new BHtmlNode("div", "class='loginLeft'");
		$page->appendNode("a", "href='{$state->baseUrl}/user?cmd=userPreferences'", "User Preferences");
		$page->appendNode("br");
		$page->appendNode("a", "href='{$state->baseUrl}/user?cmd=logout'", "Logout");
		$page->appendNode("br");
 
		return $page->render();
	}
}

function pageLogin(){
	global $state;

	$content = new BHtmlNode("div", "class='login'");
	$content->appendNode("h2", "", "Login to system");
	$f = &$page->appendNode("form", "method='post' action='{$state->baseUrl}/user?cmd=login'");
	$t = &$f->appendNode("table");
	$r = &$t->appendNode("tr");
	$c = &$r->appendNode("td");
	$c->appendText("Username");
	$c = &$r->appendNode("td");
	$c->appendNode("input", "type='text' name='username'");
	
	$r = &$t->appendNode("tr");
	$c = &$r->appendNode("td");
	$c->appendText("Password");
	$c = &$r->appendNode("td");
	$c->appendNode("input", "type='password' name='password'");
	
	$r = &$t->appendNode("tr");
	$c = &$r->appendNode("td");
	$c->appendNode("input", "type='submit' value='Login'");
	
	pageDisplay("{$state->title} - Login", $content->render());
}

function pageLogin1(){
	global $state;
	
	$content = "<div class='error'>";
	$content .= "This site is only accessable to authorised users.<br>";
	$content .= "</div>";
	$content .= "<H3>Please Login to the System</H3>";
	
	pageDisplay("{$state->title} - Login", $content);
}

function sendEmailAll($subject, $message){
	global	$state;
	
	if($state->emailSend){
		// First get list of users email addresses who want emails
		$objList = $state->db->getObjectList("User", "emailAddress", "`emailSend` = '1'", "");

		$headers = "From: {$state->siteName}<{$state->siteEmailAddress}>\n";
		$headers .= "X-Mailer: PHP/" . phpversion() . "\n";

		foreach($objList as $obj){
			mail($obj->emailAddress, $subject, $message, $headers);
		}
	}
	else {
		print "<b>Warning: Email Send disabled</b><br>";
	}
}

function runBackground($url){
	global	$state;
	
//	printf("Run: wget '{$url}' -O '{$state->baseDir}/tmp/out'<br>\n");
	exec("wget '{$url}' -O {$state->baseDir}/tmp/out > /dev/null &");
}

function modulesLoad(){
	global $state;
	
	foreach($state->modules as $module){
		require_once "{$module}/{$module}.module";
	}
}

?>
