<?php
/*******************************************************************************
 *	BDatabase.php		Database access class
 *				T.Barnaby,	BEAM Ltd,	2006-05-19
 *******************************************************************************
 */
require_once "BError.php";


function dbEscapeString($str){
	return mysql_real_escape_string($str);
}

function arrToObj($a){
	$obj = new stdClass;			// Start off a new (empty) object
	foreach($a as $key => $value){
		if(is_array($value)){		// If its multi-dimentional, keep going :)
			$obj->$key = arr2obj($value);
		}
		else{
			if(is_numeric($key)){	// Can't do it with numbers :(
				die("Cannot turn numeric arrays into objects!");
			}
			$obj->$key = $value;
		}
	}
	return $obj;
}

function objToArray($obj){
	return (array)$obj;
}

class BDatabase {
	function BDatabase(&$state){
		$this->state = $state;
		$this->objClasses = array();
		$this->db = Null;
		
		return $this->open();
	}

	function __destruct(){
		mysql_close($this->db);
	}

	function addObjectClasses($objClasses){
		$this->objClasses = array_merge($this->objClasses, $objClasses);
	}

	function getObjectClasses(){
		return $this->objClasses;
	}

	function open(){
		$err = new BError;

		$this->db = mysql_connect($this->state->databaseHost, $this->state->databaseUser, $this->state->databasePassword)
			or trigger_error("Can't connect to the database server {$this->state->databaseHost}", E_USER_ERROR);
		mysql_select_db($this->state->databaseName, $this->db)
		        or trigger_error("Can't access the database {$this->state->databaseName}: " . mysql_error() . " [#" . mysql_errno() . "]", E_USER_ERROR);
		return $err;
	}
	
	function	getObjectListRaw($table, $fields = "", $sql = ""){
		$objList = array();
		$prefixedTable = $this->state->databasePrefix . $table;

		if($fields == "")
			$fields = "*";
		else
			$fields = dbEscapeString($fields);

		$sqlCmd = "select $fields from $prefixedTable";
//		print "getListObjects: Sel: $selection Order: $order<br>\n";
		
		$sqlCmd = $sqlCmd . " " . $sql;

		if(self::$debug){		
			print "GetObjectList: SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		while($obj = mysql_fetch_object($res)){
			$objList[] = $this->convertObject($table, $obj);
		}
		mysql_free_result($res);
		return $objList;
	}

	function	getObjectList($table, $fields = "", $selection = "", $order = "", $limit = ""){
		$objList = array();
		$prefixedTable = $this->state->databasePrefix . $table;

		if($fields == "")
			$fields = "*";
		else
			$fields = dbEscapeString($fields);

		$sqlCmd = "select $fields from $prefixedTable";
//		print "getListObjects: Sel: $selection Order: $order<br>\n";
		
		if($selection != ""){
			$sqlCmd = $sqlCmd . " where " . $selection;
		} 
		if($order != ""){
			$sqlCmd = $sqlCmd . " order by " . dbEscapeString($order);
		}
		if($limit != ""){
			$sqlCmd = $sqlCmd . " limit " . dbEscapeString($limit);
		}

		if(self::$debug){		
			print "GetObjectList: SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		while($obj = mysql_fetch_object($res)){
			$objList[] = $this->convertObject($table, $obj);
		}
		mysql_free_result($res);
		return $objList;
	}
	
	function	getObject($table, $id){
		$id = dbEscapeString($id);
		$prefixedTable = $this->state->databasePrefix . $table;
		$sqlCmd = "select * from $prefixedTable where id = $id";

		if(self::$debug){		
			print "SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		$obj = mysql_fetch_object($res);
		$obj = $this->convertObject($table, $obj);

		mysql_free_result($res);

		return $obj;
	}

	// Put object functions
	function	getNewObject($table){
		if(isset($this->objClasses["$table"])){
			$obj = new $this->objClasses["$table"];
		}
		else {
			$table = $this->state->databasePrefix . $table;
			$sqlCmd = "show columns from $table";

			if(self::$debug){		
				print "SqlCmd: $sqlCmd<br>\n";
			}
			$res = mysql_query($sqlCmd, $this->db)
				or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

			$obj = new stdClass;

			while($o = mysql_fetch_object($res)){
				$obj->{$o->Field} = "";
			}			
			mysql_free_result($res);
		}
		
		return $obj;
	}
	
	function	appendObject($table, $obj){
		$table = $this->state->databasePrefix . $table;
		$s = "";
		foreach($obj as $k => $v){
			$v = dbEscapeString($v);
			if($k != "id"){
				if(strlen($s))
					$s = "$s, ";
				$s = "$s`$k`='$v'";  
			}
		}
		$sqlCmd = "insert into $table set $s";

		if(self::$debug){		
			print "SqlCmd: $sqlCmd<br>\n";
		}
		mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		// Get Object id
		$sqlCmd = "select id from $table order by id desc limit 1";
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		$o = mysql_fetch_object($res);
		mysql_free_result($res);
		
		$obj->id = $o->id;
		
		return $obj;
	}

	function	putObject($table, $obj){
		$table = $this->state->databasePrefix . $table;
		$s = "";
		foreach($obj as $k => $v){
			$v = dbEscapeString($v);
			if(strlen($s))
				$s = "$s, ";
			$s = "$s`$k`='$v'";  
		}
		$sqlCmd = "update $table set $s where id = {$obj->id}";

		if(self::$debug){		
			print "SqlCmd: $sqlCmd<br>\n";
		}
		mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);
		return $obj;
	}

	function	deleteObject($table, $id){
		$id = dbEscapeString($id);
		$prefixedTable = $this->state->databasePrefix . $table;
		$sqlCmd = "delete from $prefixedTable where id = '$id'";

		if(self::$debug){
			print "SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		return $res;
	}

	private function &convertObject($table, &$obj){
//		print "convertObject: $table "; print_r($this->objClasses); print "<br>\n";
		if(isset($this->objClasses["$table"])){
//			print "DoConvert for table: $table";
			$newObj = new $this->objClasses["$table"];
			$newObj->set($obj);
			return $newObj;
		}
		else {
			return $obj;
		}
	}

	function	getObjectNumber($table, $selection = ""){
		$prefixedTable = $this->state->databasePrefix . $table;

		$sqlCmd = "select count(id) from $prefixedTable";
		
		if($selection != ""){
			$sqlCmd = $sqlCmd . " where " . $selection;
		} 

		if(self::$debug){		
			print "GetObjectNumber: SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		$obj = mysql_fetch_array($res);
		mysql_free_result($res);
		return $obj[0];
	}

	function	query($table, $sqlCmd){
		$objList = array();
		$prefixedTable = $this->state->databasePrefix . $table;

		if(self::$debug){		
			print "GetObjectList: SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

		while($obj = mysql_fetch_object($res)){
			$objList[] = $this->convertObject($table, $obj);
		}
		mysql_free_result($res);
		return $objList;
	}
	
	function dropTable($table){
		$prefixedTable = $this->state->databasePrefix . $table;
		$sqlCmd = "DROP TABLE " . $prefixedTable;

		$res = mysql_query($sqlCmd, $this->db);
		
		return $res;
	}

	function createTable($table, $fields){
		$prefixedTable = $this->state->databasePrefix . $table;
		$sqlCmd = "CREATE TABLE " . $prefixedTable . " " . $fields . " ENGINE=MyISAM DEFAULT CHARSET=utf8;";

		if(self::$debug){
			print "SqlCmd: $sqlCmd<br>\n";
		}
		$res = mysql_query($sqlCmd, $this->db)
			or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);
		
		return $res;
	}

	function getTableInfo($table){
		$prefixedTable = $this->state->databasePrefix . $table;
		$sqlCmd = "SHOW COLUMNS FROM " . $prefixedTable;

		$res = mysql_query($sqlCmd, $this->db);
		
		return $res;
	}
	
	public static	$debug = 0;		
	private	$db;
	private	$state;	
	private	$objClasses;
};
?>
