<?php
/*******************************************************************************
 *	BDate.php		Simple Date Object
 *				(c) Terry Barnaby,	2007-02-17
 *******************************************************************************
 */

class BDate {
	function BDate($str = ""){
		$this->set($str);
	}
	
	function set($str = "", $format = "%Y-%m-%d"){
		if(is_array($str)){
			$this->timeStamp = mktime(0, 0, 0, $str[1], $str[2], $str[0]);
		}
		else {
			if($str == ""){
				$this->timeStamp = 0;
			}
			else if($str == "0000-00-00"){
				$this->timeStamp = 0;
			}
			else if($str == "now"){
				$this->timeStamp = time();
			}
			else {
				$s = strptime($str, $format);
				$this->timeStamp = mktime(0, 0, 0, $s["tm_mon"]+1, $s["tm_mday"], $s["tm_year"]);
			}
		}
	}
	function get($format = "%Y-%m-%d"){
		if($this->timeStamp == 0)
			return "";
		else
			return strftime($format, $this->timeStamp);
	}
	function getYear(){
		if($this->timeStamp == 0){
			return 0;
		}
		else {
			$s = localtime($this->timeStamp, 1);
			return $s["tm_year"] + 1900;
		}
	}
	function getMonth(){
		$s = localtime($this->timeStamp, 1);
		return $s["tm_mon"] + 1;
	}
	function getDay(){
		$s = localtime($this->timeStamp, 1);
		return $s["tm_mday"];
	}

	static function monthName($m){
		$names = array("January", "Feburary", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December");

		return $names[$m-1];
	}

	var	$timeStamp;
};

function BDateTest() {
	$d = new BDate("2005-03-20");
	$s = $d->get("%Y/%m/%d");
	print "Date: $s\n";
	print "Year: {$d->getYear()}, Mon: {$d->getMonth()}, Day: {$d->getDay()}\n";
	print "\n";
	
	$d->set();
	$s = $d->get("%Y/%m/%d");
	print "Date: $s\n";
	print "Year: {$d->getYear()}, Mon: {$d->getMonth()}, Day: {$d->getDay()}\n";
	print "\n";

	$d->set(array(2003, 11, 22));
	print "Date: {$d->get("%Y/%m/%d")}\n";
	print "Year: {$d->getYear()}, Mon: {$d->getMonth()}, Day: {$d->getDay()}\n";
	print "\n";

}

//BDateTest();

?>
