<?php


class BEditObj {
	function __construct($name = "", $title="", $saveUrl = "?cmd=save", $cancelUrl = "?cmd=cancel"){
		$this->name = $name;
		$this->title = $title;
		$this->saveUrl = $saveUrl;
		$this->cancelUrl = $cancelUrl;
		$this->saveButtonTitle = "Save";
		$this->extra = array();
		$this->numColumns = 1;
	}
	function setTitle($title){
		$this->title = $title;
	}
	function setSaveButtonTitle($title){
		$this->saveButtonTitle = $title;
	}
	function setView($viewTypeList = array()){
		$this->viewTypeList = $viewTypeList;
	}
	function setNumColumns($numColumns){
		$this->numColumns = $numColumns;
	}
	function setHelp($fieldName, $help){
		foreach($this->viewTypeList as &$field){
			if($field->name == $fieldName){
				$field->help = $help;
				break;
			}
		}
	}
	function setObj($obj){
		$this->obj = $obj;
	}
	
	function addExtra($text){
		$this->extra[] = $text;
	}
	
	function getHtml(){
		global	$state;
		
		$viewTypeList = $this->viewTypeList;
		
		// Generate list of all object members
		if(count($this->obj) and count($viewTypeList) == 0){
			foreach($this->obj as $k => $v){
				$viewTypeList[] = new BViewType($k);
			}
		}
		$f = new BHtmlNode("form", "id='BEdit_{$this->name}' name='{$this->name}' enctype='multipart/form-data' action='{$this->saveUrl}' method='post'" );
		$t = &$f->appendNode("table", "class='BEdit' cellpadding='2' cellspacing='2' border='1'");
		
		if($this->title){
			$r = &$t->appendNode("tr");
			$c = &$r->appendNode("th", "colspan=99 align=center", $this->title);
		}

		$validateErrs = $this->obj->validate();

		if(count($this->obj)){
			// Do hidden objects first, they may be needed before other fields as for the "file" input
			foreach($viewTypeList as $field){
				$obj = $this->obj;
				$type = $field->type;
				$name = $field->name;
				$value = $obj->{$field->name};
				if($type == "hidden"){
					$f->appendNode("input", "type='hidden' name='$name' value='$value'");
				}
			}
			
			$col = $this->numColumns;
			foreach($viewTypeList as $field){
				$obj = $this->obj;
				$type = $field->type;
				$name = $field->name;
				$value = $obj->{$field->name};
				$style = "";
				$title = "";
				
				if($type == "hidden"){
					continue;
				}
				else if($type == ""){
					$type = "text";
				}
				
				if($col == $this->numColumns){
					$r = &$t->appendNode("tr");
					$col = 1;
				}
				else {
					$col += 1;
				}				
//				$r = &$t->appendNode("tr");

				if($field->title)
					$s = $field->title;
				else
					$s = ucfirst($field->name);

				if($field->help){
					$title = "title='{$field->help}'";
				}

				if($field->width){
					$style .= "width: {$field->width}px;";
				}
				if($field->height){
					$style .= "height: {$field->height}px;";
				}
				
				if($style != "")
					$style = "style='{$style}'";

				$r->appendNode("th", "align = 'left'", $s);
				$c = &$r->appendNode("td");
					
				switch($type){
				case "link":
					eval("\$href = \"{$field->args[1]}\";");
					eval("\$value = \"{$field->args[0]}\";");
					$c->appendNode("a", "href=$href", $value);
					break;
				case 'textarea':
					$c->appendNode("textarea", "name='$name' {$title} {$style}", $value);
					break;
				case 'textareaHtml':
					$oFCKeditor = new FCKeditor($name);
					$oFCKeditor->BasePath	= $state->baseUrl . "/lib/fckeditor/";
					$oFCKeditor->Config['CustomConfigurationsPath'] = $state->baseUrl . "/lib/javascript/fckeditor-textfield.config.js";
					$oFCKeditor->Config['BaseHref'] = $state->baseUrl . "/" ;
					if($field->width){
						$oFCKeditor->Width	= $field->width;
					}
					if($field->height){
						$oFCKeditor->Height	= $field->height;
					}
					$oFCKeditor->ToolbarSet	= "BeamBasic";
					$oFCKeditor->Value	= $value;

					$c->appendText($oFCKeditor->CreateHtml());
					break;
				case 'checkbox':
					if($value == "1")
						$c->appendNode("input", "type='checkbox' name='{$name}_checkbox' {$title}  value='$value' checked onchange='if(this.checked) document.{$this->name}.{$name}.value = 1; else document.{$this->name}.{$name}.value = 0;'");
					else
						$c->appendNode("input", "type='checkbox' name='{$name}_checkbox' {$title}  value='$value' onchange='if(this.checked) document.{$this->name}.{$name}.value = 1; else document.{$this->name}.{$name}.value = 0;'");
					$c->appendNode("input", "type='hidden' name='$name' value='$value'");
					break;
				case 'date':
					$c->appendNode("script", "", "editorDate('BEdit_{$this->name}','{$name}','{$value}', '{$field->help}');");
					break;
				case 'date1':
					$c->appendNode("script", "", "editorDate1('BEdit_{$this->name}','{$name}','{$value}');");
					break;
				case 'date2':
					$c->appendNode("script", "", "DateInput('{$name}', false, 'YYYY-MM-DD', '{$value}');");
					break;
				case 'select':
					$sel = &$c->appendNode("select", "name='$name' {$title}  {$style}");
					foreach($field->args as $item){
						if($item == $value)
							$sel->appendNode("option", "selected='selected'", $item);
						else
							$sel->appendNode("option", "", $item);
					}
					break;
				case 'selectMulti':
					$sel = &$c->appendNode("select", "name='{$name}[]' {$title} multiple property='vectList' size='4' {$style}");
					$v = explode(",", $value);
					foreach($field->args as $item){
						if(in_array($item, $v))
							$sel->appendNode("option", "selected='selected'", $item);
						else
							$sel->appendNode("option", "", $item);
					}
					break;
				case 'selectMultiHoriz':
					$o = implode(",", $field->args);
					$sel = &$c->appendNode("script", "", "editorSelectMultiHoriz('BEdit_{$this->name}', '{$name}', '$o', '{$value}', '{$field->help}');");
					break;
				default:
					$c->appendNode("input", "type='$type' name='$name' {$title}  value='$value' size ='35' {$style}");
					break;
				}

				if(isset($validateErrs["$name"])){
					$err = $validateErrs["$name"];
					$c->appendNode("span", "class='editError'", "*** $err ***");
				}
			}
		}
		
		// Add extra elements
		foreach($this->extra as $e){
			$f->appendText($e);
		}

		$f->appendNode("input", "type='submit' name='cmd' value='{$this->saveButtonTitle}'");
		if($this->cancelUrl != "")
			$f->appendNode("button", "type='button' name='cmd' onclick='location.href = \"{$this->cancelUrl}\";'", "Cancel");
		else
			$f->appendNode("button", "type='button' name='cmd' onclick='location.href = \"javascript:history.go(-1)\";'", "Cancel");

		return $f->render();
	}
	
	var	$name;							///< This Objects name
	var	$title;							///< The title to be displayed
	var	$obj;							///< The list of objects to display
	var	$viewTypeList;						///< The list of object fields to display
	var	$saveButtonTitle;					///< The save buttons title
};

?>
