<?php
require_once 'HTML/QuickForm.php';

class BEditFObj {
	function __construct($name = "", $saveUrl = "?cmd=save"){
		$this->name = $name;
		$this->saveUrl = $saveUrl;
		$this->form = new HTML_QuickForm('{$name}Form', 'POST');
		$renderer =&$this->form->defaultRenderer();
		$renderer->setElementTemplate("\n<td valign=\"top\" align=\"left\"><!-- BEGIN error --><span style=\"color: #ff0000\">{error}</span><br /><!-- END error -->\t{element}</td>");
	}
	function setView($viewTypeList = array()){
		$this->viewTypeList = $viewTypeList;
		$this->createForm();
	}
	function setObj($obj){
		$this->obj = $obj;
		foreach($this->viewTypeList as $field){
			$e = &$this->form->getElement($field->name);
			$e->setValue($obj->{$field->name});
		}
	}
	function createForm(){
		$this->form->addElement('html', '<table style="text-align: left;" border="1" cellpadding="2" cellspacing="2"><tbody>');
		foreach($this->viewTypeList as $field){
			if($field->title)
				$title = $field->title;
			else
				$title = ucfirst($field->name);
				
			$this->form->addElement('html', '<tr>');
			$this->form->addElement('html', "<th>{$title}</th>");
			$this->form->addElement('text', "{$field->name}", '', array('size' => 35, 'maxlength' => 50));
			$this->form->addElement('html', '</tr>');
		}

		if(0){		
		// Pre-validation filters
//		$this->form->applyFilter('__ALL__', 'trim');

		// Validation rules
		$this->form->addRule('name0', 'Please enter your "Name" as it is a required field.', 'required');
		$this->form->addRule('address', 'Please enter your "Address" as it is a required field.', 'required');
		//$this->form->addRule('email', 'This is a required field.', 'required');
		//$this->form->addRule('email', 'This requires a valid email address.', 'email');
		$this->form->addRule('passport', 'This is a required field.', 'required');
		$this->form->addRule('accommodation', 'This is a required field.', 'required');
		$this->form->addRule('maps', 'Enter a number from 0 to 5.', 'numeric');
		}
		
		$buttons[] = &HTML_QuickForm::createElement('submit', 'btnSubmit', 'Update User');
		$buttons[] = &HTML_QuickForm::createElement('reset', 'btnReset', 'Clear Form');
		$buttons[] = &HTML_QuickForm::createElement('button', 'btnPrint', 'Cancel', 'onClick="window.print();"');
		$this->form->addGroup($buttons, '', '', '&nbsp;&nbsp');
		$this->form->addElement('html', '</tbody></table>');
	}
	
	function process(){
		if($this->form->validate()){
			print "Form Validated !";
			
			if(0){
			// Post-validation filters
			$form->applyFilter('__ALL__', 'addslashes');
			$form->applyFilter('__ALL__', 'htmlentities');
		//	$form->applyFilter('address', 'nl2br');
		//	$form->applyFilter('notes', 'nl2br');
		
			// invoke the "store_user_info" function to store the user information
			$form->process('storeInformation', false);

			// Exit the script, on successful insertion 
			header('Location: ./bookingFormSuccess.php');
			}
		}
		else {
		}
	}
	
	function getHtml(){
		return $this->form->toHtml();
	}
	
	var	$name;							// This Objects name
	var	$obj;							// The list of objects to display
	var	$viewTypeList;						// The list of object fields to display
};

?>
