<?php
/*******************************************************************************
 *	BHtml.php		Generates HTML
 *				T.Barnaby,	BEAM Ltd,	16/12/04
 *******************************************************************************
 */

class BHtmlNode {
	function BHtmlNode($tag, $args = "", $text = ""){
		$this->tag = $tag;
		$this->args = $args;
		$this->nodes = array();
		if($text != "")
			$this->appendText($text);
//		print("BHtmlNode: $tag, $args\n");
	}
	
	function &append($node){
		$this->nodes[] = &$node;
		return $node;
	}
	
	function &appendNode($tag, $args = "", $text = ""){
		$node = new BHtmlNode($tag, $args);
		$this->nodes[] = &$node;
		if($text != "")
			$node->appendText($text);
		return $node;
	}

	function &appendText($args){
		$node = new BHtmlNode("", $args);
		$this->nodes[] = &$node;
		return $node;
	}

	function appendTable($table, $sortUrl = ""){
		$t = new BHtmlNode("table", "cellpadding='2' cellspacing='2' border='1'");
		$r = &$t->appendNode("tr");
		foreach($table->colNames as $v){
			$c = &$r->appendNode("th");
			if($sortUrl != ""){
				$a = &$c->appendNode("a", "href=" . $sortUrl . "?tableSort=$v");
				$a->appendText($v);
			}
			else {
				$c->appendText($v);
			}
		}

		foreach($table->rows as $rd){
			$r = &$t->appendNode("tr");
			foreach($rd as $cd){
				$c = &$r->appendNode("td");
				$a = &$c->appendText($cd);
			}
		}
		$this->nodes[] = &$t;
	}

	function render($singleLine = 0){
		$str = "";

		if($singleLine)
			$end = "";
		else
			$end = "\n";
		
		$node = $this;
		
		if($node->tag == ""){
			$str = $str . $node->args;
		}
		else {
			if($node->args != ""){
				$str = $str . "<" . $node->tag . " " . $node->args . ">";
			}
			else {
				$str = $str . "<" . $node->tag . ">";
			}
			if($node->tag == "table")
				$str = $str . "<tbody>" . $end;
			else if($node->tag == "div")
				$str = $str . $end;
			
			foreach($node->nodes as $n){
				$str = $str . $n->render($singleLine);
			}
			if($node->tag == "table")
				$str = $str . "</tbody>";
			$str = $str . "</" . $node->tag . ">";

			switch($node->tag){
			case "t":
			case "table":
			case "div":
			case "li":
			case "tr":
				$str = $str . $end;
				break;
			}
		}
		return $str;
	}	

	var	$tag;
	var	$args;
	var	$nodes;
}

function	htmlParse($htmlFileName) {
	$html = array();

	$content = file_get_contents($htmlFileName);

	preg_match("/<body.*?>(.*)<\/body>/si", $content, $match);
	$html['body'] = array_key_exists("1",$match) ? $match[1] : "";

	preg_match("/<title.*?>(.*)<\/title>/si", $content, $match);
	$html['title'] = array_key_exists("1",$match) ? $match[1] : "";

	return $html;
}
?>
