<?php
/*******************************************************************************
 *	BLogin.php		Login and permittions manager
 *				T.Barnaby,	BEAM Ltd,	2006-05-08
 *******************************************************************************
 */
require_once "Auth.php";

function loginFunction1()
{
    /*
     * Change the HTML output so that it fits to your
     * application.
     */
    echo "<form method=\"post\" action=\"index.php\">";
    echo "<input type=\"text\" name=\"name\">";
    echo "<input type=\"password\" name=\"password\">";
    echo "<input type=\"submit\">";
    echo "</form>";
}

function loginFunction2()
{
    /*
     * Change the HTML output so that it fits to your
     * application.
     */
    echo "<H1>Please Login to the system</H1>";
}

class BLogin {
	function BLogin($state, $loginFunction, $showLogin = TRUE){
		$this->state = $state;
		$this->loginFunction = $loginFunction;
		$params = array(
			"dsn" => "mysql://" . $state->databaseUser . ":" . $state->databasePassword . "@" . $state->databaseHost . "/" . $state->databaseName,
			"table" => $state->databasePrefix . "User",
			"usernamecol" => "userName",
			"passwordcol" => "userPassword",
			"db_fields" => "*",
		);
		$this->auth = new Auth("DB", $params, $loginFunction, $showLogin);
		$this->start();
	}
	
	function start(){
		$this->auth->start();
	}

	function checkLogin($roles = ""){
		if($res = $this->auth->checkAuth()){
			$this->userName = $this->auth->getUsername();
			$this->id = $this->auth->getAuthData("id");
			$this->enabled = $this->auth->getAuthData("enabled");
			$this->roles = $this->auth->getAuthData("roles");
			
			if($roles != ""){
				$r1 = explode(",", $roles);
				$r2 = explode(",", $this->roles);
				$r = array_intersect($r1, $r2);
				if(count($r) == 0)
					$res = false;
			}
		}
		return $res;
	}

	function getAuth($roles = ""){
		if($res = $this->auth->getAuth()){
			$this->userName = $this->auth->getUsername();
			$this->id = $this->auth->getAuthData("id");
			$this->enabled = $this->auth->getAuthData("enabled");
			$this->roles = $this->auth->getAuthData("roles");
			
			if($roles != ""){
				$r1 = explode(",", $roles);
				$r2 = explode(",", $this->roles);
				$r = array_intersect($r1, $r2);
				if(count($r) == 0)
					$res = false;
			}
		}
		return $res;
	}

	function logout(){
		$this->auth->logout();
	}
	
	var	$id;
	var	$userName;
	var	$enabled;
	var	$roles;
};

?>
