<?php
/*******************************************************************************
 *	BMenu.php	Menu objects		
 *			(c) Terry Barnaby,	2006-05-31
 *******************************************************************************
 */
class BMenuItem {
	function BMenuItem($name, $url, $args = "", $subMenu = Null){
		$this->name = $name;
		$this->url = $url;
		$this->args = $args;
		$this->subMenu = $subMenu;
	}

	// Variables
	var	$name;		///< Displayed name of menu entry
	var	$url;		///< The URL to call
	var	$args;		///< Arguments (as <a> options)
	var	$subMenu;	///< A submenu
};

class BMenu implements IteratorAggregate {
	function BMenu($title = "", $entries = Null){
		$this->type = "BMenu";
		$this->title = $title;
		$this->entries = array();
		
		if($entries != Null){
		foreach($entries as $k => $e){
			if(is_string($e))
				$this->entries[$k] = new BMenuItem($k, $e);
			else
				$this->entries[$k] = $e;
		}
		}
	}
	
	function add($menuItem){
		$this->entries[$menuItem->name] = $menuItem;
	}
	
	function rebaseMenu($baseUrl = ""){
		global $state;

		if($baseUrl == "")
//			$baseUrl = dirname($_SERVER['PHP_SELF']);
			$baseUrl = $state->baseUrl;

		foreach($this as &$m){
//			if("https:" != substr($m->url, 0, 6) and "http:" != substr($m->url, 0, 5) and "/" != substr($m->url, 0, 1)){
			if("https:" != substr($m->url, 0, 6) and "http:" != substr($m->url, 0, 5) and "/" == substr($m->url, 0, 1)){
				$dirName = dirname($_SERVER['PHP_SELF']);
				$m->url = $baseUrl . $m->url;
			}
			if($m->subMenu)
				$m->subMenu->rebaseMenu($baseUrl);
		}
	}
	
	// Required definition of interface IteratorAggregate
	public function getIterator() {
		return new ArrayIterator($this->entries);
	}

	// Variables
	var	$type;		///< Object type
	var	$title;		///< Menu title
	var	$entries;
};

?>
