<?php
/*******************************************************************************
 *	BObj.php		
 *			(c) Terry Barnaby,	2006-06-02
 *******************************************************************************
 */
require_once "Validate.php";

class BMember {
	function BMember($name, $type, $validateType = Null, $validateArgs = Null){
		$this->name = $name;
		$this->type = $type;
		$this->validateType = $validateType;
		$this->validateArgs = $validateArgs;
	}
	
	public	$name;
	public	$type;
	public	$validateType;
	public	$validateArgs;
};

class BObj {
	function BObj($members){
		if($this->members == Null)
			$this->setMembers($members);

		foreach($members as $m){
			$this->{$m->name} = Null;
		}
	}

	function getMembers(){
		return $this->members;
	}
	
	function set($values){
		foreach($values as $k => $v){
			if(!isset($this->members["$k"]))
				continue;
			$member = $this->members["$k"];
			if(is_array($v))
				$v = implode(",", $v);
			$v = stripslashes($v);
			switch($member->type){
			case "Bool":
					if($v == "on" or $v == "1" or $v == "True")
						$this->{$k} = "1";
					else
						$this->{$k} = "0";
					break;
			case "Date":
					if($v == "0000-00-00")
						$v = "";
					$this->{$k} = $v;
					break;
			default:	$this->{$k} = $v;	break;
			}
		}
	}
	
	function validate(){
		$errs = array();
		
		$val = new Validate();
		foreach($this->members as $m){
//			print "Validate: {$m->name} Type: {$m->validateType} Args: "; print_r($m->validateArgs);
			$r = True;
			if(isset($this->{$m->name}) and $m->validateType){
				switch($m->validateType){
				case 'email':	$r = $val->email($this->{$m->name});	break;
				case 'number':	$r = $val->number($this->{$m->name}, $m->validateArgs);	break;
				case 'string':	$r = $val->string($this->{$m->name}, $m->validateArgs);	break;
				case 'date':
					if(($this->{$m->name} != "0000-00-00") && ($this->{$m->name} != "")){
						if(! $a = $m->validateArgs)
							$a = array('format' => '%Y-%n-%j');
						$v = $this->{$m->name};
//						print("DoValidate: $v $a\n");
						$r = $val->date($this->{$m->name}, $a);	break;
					}
				}
			}
			if(!$r)
				$errs["{$m->name}"] = "Error";
		}

		if(!count($errs))
			$errs = Null;
		return $errs;
	}

	function dbTableFields(){
		return "";
	}

	function dbTableSetup($table){
		return "";
	}

	// Private functions
	function setMembers($members){
		$this->members = array();
		foreach($members as $m){
			$this->members["{$m->name}"] = $m;
//			$this->{$m->name} = Null;
		}
	}
	
	function addMember($member){
		$this->members[] = $member;
	}

	// Variables
	private	$members = Null;
};

?>
