<?php
/*******************************************************************************
 *	BState.php		The state of a session
 *				T.Barnaby,	BEAM Ltd,	2006-05-19
 *******************************************************************************
 */
class BState {
	function BState(){
	}
	
	function init(){
		// Create base URL
		$baseRoot = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https' : 'http';

		// As $_SERVER['HTTP_HOST'] is user input, ensure it only contains characters allowed in hostnames.
		$this->baseUrl = $baseRoot .= '://'. preg_replace('/[^a-z0-9-:._]/i', '', $_SERVER['HTTP_HOST']);

		// $_SERVER['SCRIPT_NAME'] can, in contrast to $_SERVER['PHP_SELF'], not be modified by a visitor.
		if($dir = trim(dirname($_SERVER['SCRIPT_NAME']), '\,/')){
			$basePath = "/$dir";
			$this->baseUrl .= $basePath;
			$basePath .= '/';
		}
		else {
			$basePath = '/';
		}
		$this->basePath = $basePath;
		$this->baseDir = getcwd();
		
//		print "Init: BaseUrl: {$this->baseUrl} BasePath: {$this->basePath} BaseDir: {$this->baseDir}<br>\n";
//		foreach($_SERVER as $k => $v){
//			print "$k => $v<br>\n";
//		}

		// Chec out browser type
		if(isset($_SERVER['HTTP_USER_AGENT']) and preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT']))
			$this->browser = "MSIE";
		else
			$this->browser = "";

	}

	
	// Core information
	var	$databaseHost;
	var	$databaseName;
	var	$databaseUser;
	var	$databasePassword;
	var	$databasePrefix;

	// These could be in database ??
	var	$siteName;
	var	$siteTitle;
	var	$siteEmailAddress;
	var	$baseDir;
	var	$baseUrl;
	var	$basePath;				// The base URI
	var	$modules;				// The list of modules used
	var	$loginRequired;				// Boolean indicationg that a login is required for normal site access

	// GUI bits
	var	$style;
	var	$logo;
	var	$title;
	var	$motto;

	var	$page;					// The output page
	var	$user;					// User information
};

?>
