-- MySQL dump 10.11
--
-- Host: localhost    Database: BDS_WEB
-- ------------------------------------------------------
-- Server version	5.0.45

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `bds_web_Category`
--

DROP TABLE IF EXISTS `bds_web_Category`;
CREATE TABLE `bds_web_Category` (
  `id` int(11) NOT NULL auto_increment,
  `group` text,
  `value` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Category`
--

LOCK TABLES `bds_web_Category` WRITE;
/*!40000 ALTER TABLE `bds_web_Category` DISABLE KEYS */;
INSERT INTO `bds_web_Category` (`id`, `group`, `value`) VALUES (1,'Groups','content'),(2,'Groups','calendar'),(3,'Groups','news'),(4,'Groups','classes');
/*!40000 ALTER TABLE `bds_web_Category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_Content`
--

DROP TABLE IF EXISTS `bds_web_Content`;
CREATE TABLE `bds_web_Content` (
  `id` int(11) NOT NULL auto_increment,
  `version` int(11) default '0',
  `type` text,
  `title` text,
  `category` text,
  `description` text,
  `content` text,
  `filePath` text,
  `fileNameOriginal` text,
  `dateCreated` date default NULL,
  `dateModified` date default NULL,
  `uid` int(11) default '0',
  `access` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Content`
--

LOCK TABLES `bds_web_Content` WRITE;
/*!40000 ALTER TABLE `bds_web_Content` DISABLE KEYS */;
/*!40000 ALTER TABLE `bds_web_Content` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_Forum`
--

DROP TABLE IF EXISTS `bds_web_Forum`;
CREATE TABLE `bds_web_Forum` (
  `id` int(11) NOT NULL auto_increment,
  `name` text,
  `title` text,
  `userIds` text,
  `dateAdded` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Forum`
--

LOCK TABLES `bds_web_Forum` WRITE;
/*!40000 ALTER TABLE `bds_web_Forum` DISABLE KEYS */;
/*!40000 ALTER TABLE `bds_web_Forum` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_ForumEntry`
--

DROP TABLE IF EXISTS `bds_web_ForumEntry`;
CREATE TABLE `bds_web_ForumEntry` (
  `id` int(11) NOT NULL auto_increment,
  `forum` text,
  `title` text,
  `type` text,
  `content` text,
  `filePath` text,
  `userEmail` text,
  `userName` text,
  `dateAdded` datetime default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_ForumEntry`
--

LOCK TABLES `bds_web_ForumEntry` WRITE;
/*!40000 ALTER TABLE `bds_web_ForumEntry` DISABLE KEYS */;
/*!40000 ALTER TABLE `bds_web_ForumEntry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_Picture`
--

DROP TABLE IF EXISTS `bds_web_Picture`;
CREATE TABLE `bds_web_Picture` (
  `id` int(11) NOT NULL auto_increment,
  `title` text,
  `category` text,
  `description` text NOT NULL,
  `dateAdded` date default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Picture`
--

LOCK TABLES `bds_web_Picture` WRITE;
/*!40000 ALTER TABLE `bds_web_Picture` DISABLE KEYS */;
/*!40000 ALTER TABLE `bds_web_Picture` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_Showcase`
--

DROP TABLE IF EXISTS `bds_web_Showcase`;
CREATE TABLE `bds_web_Showcase` (
  `id` int(11) NOT NULL auto_increment,
  `title` text,
  `description` text NOT NULL,
  `dateAdded` date default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Showcase`
--

LOCK TABLES `bds_web_Showcase` WRITE;
/*!40000 ALTER TABLE `bds_web_Showcase` DISABLE KEYS */;
/*!40000 ALTER TABLE `bds_web_Showcase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_Statistics`
--

DROP TABLE IF EXISTS `bds_web_Statistics`;
CREATE TABLE `bds_web_Statistics` (
  `id` int(11) NOT NULL auto_increment,
  `dateAdded` datetime default NULL,
  `uri` text,
  `fromIp` text,
  `fromHost` text,
  `fromPage` text,
  `userAgent` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=435 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_Statistics`
--

LOCK TABLES `bds_web_Statistics` WRITE;
/*!40000 ALTER TABLE `bds_web_Statistics` DISABLE KEYS */;
INSERT INTO `bds_web_Statistics` (`id`, `dateAdded`, `uri`, `fromIp`, `fromHost`, `fromPage`, `userAgent`) VALUES (1,'2008-07-17 10:10:05','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(2,'2008-07-17 10:10:05','/src/blacknest/bds/src/bdsWeb/www/beamLogo.gif','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(3,'2008-07-17 10:15:16','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(4,'2008-07-17 10:15:16','/src/blacknest/bds/src/bdsWeb/www/bdsLogo.gif','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(5,'2008-07-17 10:15:19','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(6,'2008-07-17 10:15:19','/src/blacknest/bds/src/bdsWeb/www/bdsLogo.gif','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(7,'2008-07-17 10:15:21','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(8,'2008-07-17 10:15:22','/src/blacknest/bds/src/bdsWeb/www/bdsLogo.gif','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(9,'2008-07-17 10:16:31','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(10,'2008-07-17 10:16:31','/src/blacknest/bds/src/bdsWeb/www/bdsLogo.gif','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(11,'2008-07-17 10:21:51','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(12,'2008-07-17 10:24:48','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(13,'2008-07-17 10:26:38','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(14,'2008-07-17 10:26:42','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(15,'2008-07-17 10:26:48','/src/blacknest/bds/src/bdsWeb/www/showcase','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(16,'2008-07-17 10:26:49','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(17,'2008-07-17 10:26:52','/src/blacknest/bds/src/bdsWeb/www/document','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(18,'2008-07-17 10:26:54','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(19,'2008-07-17 10:26:57','/src/blacknest/bds/src/bdsWeb/www/files/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(20,'2008-07-17 10:27:00','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(21,'2008-07-17 10:28:40','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(22,'2008-07-17 10:28:43','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(23,'2008-07-17 10:28:46','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(24,'2008-07-17 10:28:59','/src/blacknest/bds/src/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(25,'2008-07-17 10:29:03','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(26,'2008-07-17 10:29:08','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(27,'2008-07-17 10:33:32','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(28,'2008-07-17 10:34:44','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(29,'2008-07-17 10:34:47','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(30,'2008-07-17 11:28:05','/src/blacknest/bds/src/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(31,'2008-07-17 11:28:08','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(32,'2008-07-17 11:29:14','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(33,'2008-07-17 11:29:33','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(34,'2008-07-17 11:29:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(35,'2008-07-17 11:37:52','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(36,'2008-07-17 11:37:56','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(37,'2008-07-17 11:39:11','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(38,'2008-07-17 11:39:39','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(39,'2008-07-17 11:40:37','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(40,'2008-07-17 11:44:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(41,'2008-07-17 11:46:52','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(42,'2008-07-17 11:48:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(43,'2008-07-17 11:49:09','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(44,'2008-07-17 11:49:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataView','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(45,'2008-07-17 11:50:10','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataView','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(46,'2008-07-17 11:52:21','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataView','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(47,'2008-07-17 11:52:41','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(48,'2008-07-17 11:55:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(49,'2008-07-17 11:55:49','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(50,'2008-07-17 11:55:51','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(51,'2008-07-17 11:56:19','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(52,'2008-07-17 11:56:24','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(53,'2008-07-17 11:56:27','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(54,'2008-07-17 11:56:56','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(55,'2008-07-17 11:57:01','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(56,'2008-07-17 11:57:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(57,'2008-07-17 11:57:09','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(58,'2008-07-17 11:57:13','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(59,'2008-07-17 11:58:02','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(60,'2008-07-17 11:58:37','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(61,'2008-07-17 12:06:58','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(62,'2008-07-17 12:07:27','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(63,'2008-07-17 12:07:42','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(64,'2008-07-17 12:14:39','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(65,'2008-07-17 12:14:43','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(66,'2008-07-17 12:14:45','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(67,'2008-07-17 12:14:47','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(68,'2008-07-17 12:15:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(69,'2008-07-17 12:16:04','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(70,'2008-07-17 12:16:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(71,'2008-07-17 12:16:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(72,'2008-07-17 12:19:27','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(73,'2008-07-17 12:19:31','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(74,'2008-07-17 12:19:33','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(75,'2008-07-17 12:29:29','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(76,'2008-07-17 12:29:31','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewInfo&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(77,'2008-07-17 12:29:33','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(78,'2008-07-17 13:20:03','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(79,'2008-07-17 13:20:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(80,'2008-07-17 13:20:10','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(81,'2008-07-17 13:20:21','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(82,'2008-07-17 13:20:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewInfo&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(83,'2008-07-17 13:20:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewInfo&id=undefined','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(84,'2008-07-17 13:21:28','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(85,'2008-07-17 13:59:21','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(86,'2008-07-17 13:59:39','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(87,'2008-07-17 14:00:53','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(88,'2008-07-17 14:01:18','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(89,'2008-07-17 14:01:24','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(90,'2008-07-17 14:01:59','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(91,'2008-07-17 14:02:13','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(92,'2008-07-17 14:03:32','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(93,'2008-07-17 14:04:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(94,'2008-07-17 14:04:54','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(95,'2008-07-17 14:05:18','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(96,'2008-07-17 14:09:49','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(97,'2008-07-17 14:10:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(98,'2008-07-17 14:11:47','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(99,'2008-07-17 14:11:58','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(100,'2008-07-17 14:12:04','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(101,'2008-07-17 14:12:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(102,'2008-07-17 14:12:13','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(103,'2008-07-17 14:22:47','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(104,'2008-07-17 14:23:59','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(105,'2008-07-17 14:24:10','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(106,'2008-07-17 14:25:24','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(107,'2008-07-17 14:26:15','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(108,'2008-07-17 14:33:17','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(109,'2008-07-17 14:34:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(110,'2008-07-17 14:34:38','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(111,'2008-07-17 14:35:17','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(112,'2008-07-17 14:35:34','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(113,'2008-07-17 14:36:32','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(114,'2008-07-17 14:46:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(115,'2008-07-17 14:52:00','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(116,'2008-07-17 14:55:22','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(117,'2008-07-17 15:02:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(118,'2008-07-17 15:03:44','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(119,'2008-07-17 15:04:18','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(120,'2008-07-17 15:13:21','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(121,'2008-07-17 15:15:21','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(122,'2008-07-17 15:16:11','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(123,'2008-07-17 15:20:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(124,'2008-07-17 15:20:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(125,'2008-07-17 15:21:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(126,'2008-07-17 15:21:18','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(127,'2008-07-17 15:22:14','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(128,'2008-07-17 15:23:33','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(129,'2008-07-17 15:25:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(130,'2008-07-17 15:25:17','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(131,'2008-07-17 15:26:51','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(132,'2008-07-17 15:26:56','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(133,'2008-07-17 15:27:19','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(134,'2008-07-17 15:27:59','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(135,'2008-07-17 15:28:55','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(136,'2008-07-17 15:29:05','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(137,'2008-07-17 15:29:10','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(138,'2008-07-17 15:32:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(139,'2008-07-17 15:32:53','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(140,'2008-07-17 15:33:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(141,'2008-07-17 15:35:45','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(142,'2008-07-17 15:35:52','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(143,'2008-07-17 15:35:59','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(144,'2008-07-17 15:36:30','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(145,'2008-07-17 15:36:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(146,'2008-07-17 15:37:17','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(147,'2008-07-17 15:37:27','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(148,'2008-07-17 15:40:01','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(149,'2008-07-17 15:40:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(150,'2008-07-17 15:40:58','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(151,'2008-07-17 15:42:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(152,'2008-07-17 15:42:27','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(153,'2008-07-17 15:42:42','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(154,'2008-07-17 15:42:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(155,'2008-07-17 15:43:05','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(156,'2008-07-17 15:43:37','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(157,'2008-07-17 15:44:29','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(158,'2008-07-17 15:44:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(159,'2008-07-17 15:45:04','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(160,'2008-07-17 15:45:13','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=3','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(161,'2008-07-17 15:51:08','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(162,'2008-07-17 15:56:16','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(163,'2008-07-17 15:56:24','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(164,'2008-07-17 15:56:43','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(165,'2008-07-17 15:57:28','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(166,'2008-07-17 15:57:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(167,'2008-07-17 16:00:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(168,'2008-07-17 16:01:09','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(169,'2008-07-17 16:01:52','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(170,'2008-07-17 16:02:11','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(171,'2008-07-17 16:02:55','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(172,'2008-07-17 16:03:07','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(173,'2008-07-17 16:04:09','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(174,'2008-07-17 16:11:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(175,'2008-07-17 16:12:03','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(176,'2008-07-17 16:12:10','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(177,'2008-07-17 16:12:18','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(178,'2008-07-17 16:12:50','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(179,'2008-07-17 16:12:56','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=6','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(180,'2008-07-17 16:12:59','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(181,'2008-07-17 16:13:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(182,'2008-07-17 16:13:08','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(183,'2008-07-17 16:13:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(184,'2008-07-17 16:13:44','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=5','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(185,'2008-07-17 16:13:47','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(186,'2008-07-17 16:13:54','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(187,'2008-07-17 16:13:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(188,'2008-07-17 16:15:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(189,'2008-07-17 16:15:26','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(190,'2008-07-17 16:15:31','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(191,'2008-07-17 16:15:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(192,'2008-07-17 16:15:38','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(193,'2008-07-17 16:15:40','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.15) Gecko/20080702 Fedora/2.0.0.15-1.fc8 Firefox/2.0.0.15'),(194,'2008-07-21 15:17:06','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(195,'2008-07-21 15:17:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(196,'2008-07-21 15:17:33','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(197,'2008-07-21 15:17:48','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(198,'2008-07-21 15:17:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(199,'2008-07-21 17:12:36','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(200,'2008-07-21 17:13:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(201,'2008-07-21 17:14:46','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(202,'2008-07-21 17:15:34','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(203,'2008-07-21 17:15:35','/src/blacknest/bds/src/bdsWeb/www/files/tmp/graph.png','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(204,'2008-07-21 17:16:24','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(205,'2008-07-21 17:19:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(206,'2008-07-21 17:20:05','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(207,'2008-07-21 17:20:43','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(208,'2008-07-21 17:20:53','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=3','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(209,'2008-07-21 17:21:13','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=3','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(210,'2008-07-21 17:21:15','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewInfo&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(211,'2008-07-21 17:21:17','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=3','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(212,'2008-07-21 17:21:23','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(213,'2008-07-21 17:21:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=3','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(214,'2008-07-22 11:15:25','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(215,'2008-07-22 11:15:32','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewData&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(216,'2008-07-22 11:15:35','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(217,'2008-07-22 11:15:39','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=1','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(218,'2008-07-22 11:15:50','/src/blacknest/bds/src/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(219,'2008-07-22 11:16:02','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=2','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(220,'2008-07-22 11:16:26','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=2','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(221,'2008-07-22 11:16:48','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(222,'2008-07-22 11:16:57','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(223,'2008-07-22 11:17:03','/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/src/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(224,'2008-07-31 16:08:01','/src/blacknest/bds/bds/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(225,'2008-07-31 16:08:06','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(226,'2008-07-31 16:09:32','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(227,'2008-07-31 16:29:06','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(228,'2008-07-31 16:29:38','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(229,'2008-07-31 16:29:51','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(230,'2008-07-31 16:31:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(231,'2008-07-31 16:38:28','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(232,'2008-07-31 16:39:42','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(233,'2008-07-31 16:43:18','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(234,'2008-07-31 16:43:33','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(235,'2008-07-31 16:44:30','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(236,'2008-07-31 16:44:59','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(237,'2008-07-31 16:46:07','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(238,'2008-07-31 16:46:13','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(239,'2008-07-31 16:46:38','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(240,'2008-07-31 16:47:35','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(241,'2008-07-31 16:47:41','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(242,'2008-07-31 16:47:48','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(243,'2008-07-31 16:47:54','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(244,'2008-07-31 16:48:07','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(245,'2008-07-31 16:48:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(246,'2008-07-31 16:48:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(247,'2008-07-31 16:48:30','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(248,'2008-07-31 16:48:36','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(249,'2008-07-31 16:49:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(250,'2008-07-31 16:50:46','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(251,'2008-07-31 16:50:56','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(252,'2008-07-31 16:51:00','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(253,'2008-08-05 15:26:08','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(254,'2008-08-05 15:29:07','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(255,'2008-08-05 15:30:59','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(256,'2008-08-05 15:31:37','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(257,'2008-08-05 15:31:44','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(258,'2008-08-05 15:32:14','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(259,'2008-08-05 15:32:17','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(260,'2008-08-05 15:33:32','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(261,'2008-08-05 15:34:04','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(262,'2008-08-05 15:35:07','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think.beamnet/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(263,'2008-08-05 15:35:12','/bds/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://think/bds/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(264,'2008-08-05 15:46:12','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(265,'2008-08-05 15:46:14','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(266,'2008-08-05 15:52:42','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(267,'2008-08-05 15:52:58','/bds/bdsdata?cmd=viewData&id=undefined','192.168.1.1','beam.beamnet','http://think/bds/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(268,'2008-08-05 15:53:01','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(269,'2008-08-05 15:53:06','/bds/bdsdata?cmd=viewData&id=0','192.168.1.1','beam.beamnet','http://think/bds/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(270,'2008-08-05 15:53:10','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(271,'2008-08-05 15:53:16','/bds/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://think/bds/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(272,'2008-08-05 15:59:34','/bds/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://think/bds/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(273,'2008-08-05 16:20:01','/bds/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(274,'2008-08-05 16:20:04','/bds/bdsdata','192.168.1.1','beam.beamnet','http://think/bds/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(275,'2008-09-01 13:22:13','/src/blacknest/bds/bds/bdsWeb/www/','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(276,'2008-09-01 13:22:16','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(277,'2008-09-01 13:30:17','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(278,'2008-09-01 13:33:47','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(279,'2008-09-01 13:34:25','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(280,'2008-09-01 13:34:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=undefined','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(281,'2008-09-01 13:34:45','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(282,'2008-09-01 13:35:03','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph&id=0','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(283,'2008-09-01 13:35:18','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(284,'2008-09-01 14:13:46','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(285,'2008-09-01 14:14:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(286,'2008-09-01 14:14:27','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(287,'2008-09-01 14:14:49','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(288,'2008-09-01 14:14:53','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(289,'2008-09-01 14:15:25','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(290,'2008-09-01 14:15:42','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(291,'2008-09-01 14:17:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(292,'2008-09-01 14:18:08','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(293,'2008-09-01 14:19:37','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(294,'2008-09-01 14:19:59','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(295,'2008-09-01 14:20:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(296,'2008-09-01 14:26:33','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(297,'2008-09-01 14:26:58','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(298,'2008-09-01 14:34:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(299,'2008-09-01 14:34:42','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(300,'2008-09-01 14:35:56','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(301,'2008-09-01 14:41:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(302,'2008-09-01 14:42:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(303,'2008-09-01 14:56:36','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(304,'2008-09-01 14:56:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(305,'2008-09-01 14:57:00','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(306,'2008-09-01 14:57:51','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(307,'2008-09-01 14:58:19','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(308,'2008-09-01 14:59:26','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(309,'2008-09-01 15:00:02','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(310,'2008-09-01 15:01:37','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(311,'2008-09-01 15:02:28','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(312,'2008-09-01 15:02:32','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(313,'2008-09-01 15:02:35','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(314,'2008-09-01 15:07:41','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(315,'2008-09-01 15:12:34','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(316,'2008-09-01 15:12:43','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(317,'2008-09-01 15:13:48','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(318,'2008-09-01 15:14:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(319,'2008-09-01 15:14:32','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(320,'2008-09-01 15:15:25','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(321,'2008-09-01 15:15:46','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(322,'2008-09-01 15:17:28','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(323,'2008-09-01 15:18:29','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(324,'2008-09-01 15:18:43','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(325,'2008-09-01 15:23:52','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(326,'2008-09-01 15:24:51','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(327,'2008-09-01 15:25:49','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(328,'2008-09-01 15:25:54','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(329,'2008-09-01 15:25:56','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(330,'2008-09-01 15:25:59','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(331,'2008-09-01 15:26:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(332,'2008-09-01 15:27:34','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(333,'2008-09-01 15:27:46','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(334,'2008-09-01 15:28:23','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(335,'2008-09-01 15:28:26','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(336,'2008-09-01 15:28:28','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(337,'2008-09-01 15:28:47','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(338,'2008-09-01 15:30:13','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(339,'2008-09-01 15:35:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(340,'2008-09-01 15:36:14','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(341,'2008-09-01 15:36:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(342,'2008-09-01 15:36:24','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(343,'2008-09-01 15:41:27','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(344,'2008-09-01 15:42:00','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(345,'2008-09-01 15:42:04','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(346,'2008-09-01 15:42:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(347,'2008-09-01 15:44:35','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(348,'2008-09-01 15:44:39','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(349,'2008-09-01 15:44:42','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(350,'2008-09-01 15:44:49','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(351,'2008-09-01 16:14:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(352,'2008-09-01 16:14:26','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(353,'2008-09-01 16:15:01','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(354,'2008-09-01 16:17:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(355,'2008-09-01 16:18:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(356,'2008-09-01 16:24:31','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(357,'2008-09-01 16:24:36','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(358,'2008-09-01 16:24:58','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(359,'2008-09-01 16:25:09','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(360,'2008-09-01 16:25:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(361,'2008-09-01 16:25:38','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(362,'2008-09-01 16:25:43','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(363,'2008-09-01 16:29:06','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(364,'2008-09-01 16:29:08','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewInfo','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(365,'2008-09-01 16:30:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(366,'2008-09-01 16:38:33','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(367,'2008-09-01 16:38:47','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(368,'2008-09-01 16:39:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(369,'2008-09-01 16:39:50','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(370,'2008-09-01 16:41:24','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(371,'2008-09-01 16:41:51','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(372,'2008-09-01 16:44:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(373,'2008-09-01 16:44:14','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(374,'2008-09-01 16:44:16','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(375,'2008-09-01 16:44:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(376,'2008-09-01 16:44:23','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(377,'2008-09-01 16:44:27','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(378,'2008-09-01 16:44:31','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(379,'2008-09-01 16:50:11','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(380,'2008-09-01 16:50:16','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(381,'2008-09-01 16:51:17','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(382,'2008-09-01 16:51:21','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(383,'2008-09-01 16:52:00','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(384,'2008-09-01 16:56:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(385,'2008-09-01 16:58:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(386,'2008-09-01 16:59:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(387,'2008-09-01 16:59:44','/src/blacknest/bds/bds/bdsWeb/www/files/tmp/data.txt','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(388,'2008-09-01 16:59:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(389,'2008-09-01 17:01:56','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(390,'2008-09-01 17:02:46','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(391,'2008-09-01 17:02:52','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(392,'2008-09-01 17:02:59','/src/blacknest/bds/bds/bdsWeb/www/files/index.html','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(393,'2008-09-01 17:03:05','/src/blacknest/bds/bds/bdsWeb/www/document','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/files/index.html','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(394,'2008-09-01 17:03:16','/src/blacknest/bds/bds/bdsWeb/www/bdsdata','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/document','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(395,'2008-09-01 17:03:32','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(396,'2008-09-01 17:03:39','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(397,'2008-09-01 17:03:45','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(398,'2008-09-01 17:03:51','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(399,'2008-09-01 17:03:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(400,'2008-09-01 17:04:19','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(401,'2008-09-01 17:04:24','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(402,'2008-09-01 17:04:30','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(403,'2008-09-01 17:05:38','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(404,'2008-09-01 17:08:05','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(405,'2008-09-01 17:08:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(406,'2008-09-01 17:08:17','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(407,'2008-09-01 17:08:19','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(408,'2008-09-01 17:08:22','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=downloadData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(409,'2008-09-01 17:08:29','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(410,'2008-09-01 17:08:35','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(411,'2008-09-01 17:08:41','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(412,'2008-09-01 17:08:43','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(413,'2008-09-01 17:08:48','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(414,'2008-09-01 17:08:54','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(415,'2008-09-01 17:09:00','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(416,'2008-09-01 17:09:05','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(417,'2008-09-01 17:09:12','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(418,'2008-09-01 17:09:14','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(419,'2008-09-01 17:09:17','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(420,'2008-09-01 17:09:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(421,'2008-09-01 17:10:59','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewGraph','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(422,'2008-09-01 17:11:11','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(423,'2008-09-01 17:12:17','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(424,'2008-09-01 17:13:10','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(425,'2008-09-02 10:16:20','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(426,'2008-09-02 10:16:38','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(427,'2008-09-02 10:16:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(428,'2008-09-02 10:17:05','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(429,'2008-09-02 10:20:28','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(430,'2008-09-02 10:20:57','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(431,'2008-09-02 10:21:06','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(432,'2008-09-02 10:21:36','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(433,'2008-09-02 10:21:40','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=viewData','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16'),(434,'2008-09-02 10:22:27','/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','192.168.1.1','beam.beamnet','http://beam.beamnet/src/blacknest/bds/bds/bdsWeb/www/bdsdata?cmd=dataSelect','Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.8.1.16) Gecko/20080715 Fedora/2.0.0.16-1.fc8 Firefox/2.0.0.16');
/*!40000 ALTER TABLE `bds_web_Statistics` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bds_web_User`
--

DROP TABLE IF EXISTS `bds_web_User`;
CREATE TABLE `bds_web_User` (
  `id` int(11) NOT NULL auto_increment,
  `enabled` int(11) default NULL,
  `name` text,
  `userName` text NOT NULL,
  `userPassword` text,
  `postalAddress` text,
  `emailAddress` text,
  `telephoneHome` text,
  `telephoneWork` text,
  `telephoneMobile` text,
  `roles` text,
  `dateAdded` date default NULL,
  `registered` int(11) default NULL,
  `registerPassword` text,
  `emailSend` int(11) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;

--
-- Dumping data for table `bds_web_User`
--

LOCK TABLES `bds_web_User` WRITE;
/*!40000 ALTER TABLE `bds_web_User` DISABLE KEYS */;
INSERT INTO `bds_web_User` (`id`, `enabled`, `name`, `userName`, `userPassword`, `postalAddress`, `emailAddress`, `telephoneHome`, `telephoneWork`, `telephoneMobile`, `roles`, `dateAdded`, `registered`, `registerPassword`, `emailSend`) VALUES (1,1,'root','root','3770f039443414ce93a39ca4e8897027','','','','','','admin,adminUsers,adminPages,adminDelete','2008-07-17',0,'',0);
/*!40000 ALTER TABLE `bds_web_User` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2008-09-02 11:38:54
